(* Test script for some Arithmetic expressions with a Modula-2 compiler *)
(*       051704     for Stony Brook  *)

fail_handling continue
error_handling stop

context FROM M2EXCEPTION IMPORT IsM2Exception;
        <*/NOOPTIMIZE*>  (* Otherwise, some of the simple tests below disappear! *)

***** INTEGER Overflow
define  Result, I, J, K  :INTEGER16;
prepare <*/PUSH*>
        <*/CHECK:O*>
        Result := 0;
        I := 30000; J := -30000;
test    Result := I-J;
pass    exception IsM2Exception()
cleanup <*/POP*>

***** INTEGER Overflow without checking
define  Result, I, J, K  :INTEGER16;
prepare <*/PUSH*>
        <*/NOCHECK:O*>
        Result := 0;
        I := 30000; J := -30000;
test    Result := I-J;
pass    TRUE
cleanup <*/POP*>

***** CARDINAL Overflow
define  Result, I, J, K  :CARDINAL16;
prepare <*/PUSH*>
        <*/CHECK:O*>
        Result := 0;
        I := 35000; J := 35000;
test    Result := I+J;
pass    exception IsM2Exception()
cleanup <*/POP*>

***** CARDINAL Overflow without checking
define  Result, I, J, K  :CARDINAL16;
prepare <*/PUSH*>
        <*/NOCHECK:O*>
        Result := 0;
        I := 35000; J := 35000;
test    Result := I+J;
pass    TRUE
cleanup <*/POP*>

***** MIN(INTEGER) CONST calculation
define  Result :INTEGER16;
prepare <*/PUSH*>
        <*/CHECK:O*>
        Result := 0;
test    Result := -MAX(INTEGER16) -1;
pass    Result = -32768
cleanup <*/POP*>

***** MAX(INTEGER) CONST calculation
define  Result :INTEGER16;
prepare <*/PUSH*>
        <*/CHECK:O*>
        Result := 0;
test    Result := MAX(INTEGER16);
        Result := Result+1;
pass    exception IsM2Exception()
cleanup <*/POP*>

