(* Test script for tgM2Parser 5/13/04 *)

fail_handling continue

context FROM Debugging0     IMPORT Assert;
        FROM ChanConsts     IMPORT OpenResults;
        FROM IOChan         IMPORT ChanId, InvalidChan;
        IMPORT TextIO              (*WriteChar, WriteLn, WriteString*);
        FROM TBChans        IMPORT Close, OpenTB, Reread, Rewrite;
        FROM tgM2Parser     IMPORT Code_List, General_Part_Type, Get_Code_Part, Get_General_Part, Get_Test_Case, Test_Case_Type;
        FROM tgM2Scanner    IMPORT Current_Token, InitScanner, Next_Token, Token;
        FROM tgM2Exceptions IMPORT IstgException, Raise, tgExceptions;

define    Script_File :ChanId;
          oRes        :OpenResults;

code      Script_File := InvalidChan();
          OpenTB(Script_File, oRes);
          Assert(oRes = opened, "OpenTB FAIL");

***** invalid first keyword
define    gp      :General_Part_Type;
          OneLine :ARRAY[0..133] OF CHAR;
prepare   Rewrite(Script_File);
          TextIO.WriteString(Script_File, "fail_hndling stop"); TextIO.WriteLn(Script_File);
          gp := NIL;
          Reread(Script_File);
          InitScanner(Script_File);
test      Next_Token;
          Get_General_Part(gp);
          IF Current_Token() = Error THEN
             Raise(Syntax_Error);
          END;
pass exception TRUE
(*cleanup   DisposeGP(gp);*)

***** invalid second keyword
define    gp      :General_Part_Type;
          OneLine :ARRAY[0..133] OF CHAR;
prepare   Rewrite(Script_File);
          TextIO.WriteString(Script_File, "fail_handling stp"); TextIO.WriteLn(Script_File);
          gp := NIL;
          Reread(Script_File);
          InitScanner(Script_File);
test      Next_Token;
          Get_General_Part(gp);
          IF Current_Token() = Error THEN
             Raise(Syntax_Error);
          END;
pass exception IstgException()
(*cleanup   DisposeGP(gp);*)

***** wrong second keyword
define    gp      :General_Part_Type;
          OneLine :ARRAY[0..133] OF CHAR;
prepare   Rewrite(Script_File);
          TextIO.WriteString(Script_File, "fail_handling error_handling"); TextIO.WriteLn(Script_File);
          gp := NIL;
          Reread(Script_File);
          InitScanner(Script_File);
test      Next_Token;
          Get_General_Part(gp);
          IF Current_Token() = Error THEN
             Raise(Syntax_Error);
          END;
pass exception IstgException()
(*cleanup   DisposeGP(gp);*)

***** keyword out of keyword context
define    gp      :General_Part_Type;
          OneLine :ARRAY[0..133] OF CHAR;
prepare   Rewrite(Script_File);
          TextIO.WriteString(Script_File, "fail_handling stop"); TextIO.WriteLn(Script_File);
          TextIO.WriteString(Script_File, "define  code :INTEGER;"); TextIO.WriteLn(Script_File);
          TextIO.WriteString(Script_File, "code  code := 1;"); TextIO.WriteLn(Script_File);
          TextIO.WriteString(Script_File, "      code := 2;"); TextIO.WriteLn(Script_File);
          gp := NIL;
          Reread(Script_File);
          InitScanner(Script_File);
test      Next_Token;
          Get_General_Part(gp);
          IF Current_Token() = Error THEN
             Raise(Syntax_Error);
          END;
pass      TRUE
(*cleanup   DisposeGP(gp);*)

code      Close(Script_File);
