
(*#############################*)
 IMPLEMENTATION MODULE DynStr1C;         (* v1.0x-012187 *)
(*#############################*)
                                       (* by Thomas Breeden, tmb@virginia.edu *)
(*
        Char params for dynamically allocated string processing.
*)

(*
Copyright (C) 1987 Thomas Breeden.

Permission to use, copy, modify and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided that
the above copyright notice appear in all copies and that both the copyright
notice and this permission notice appear in supporting documentation.
Thomas Breeden makes no representations about the suitability of this software
for any purpose. It is provided "as is" without express or implied warranty.
*)

FROM DynStr0 IMPORT DynStr, dStrInE, dStrInC, dStrDispose;
FROM DynStr1 IMPORT dStrCat, dStrPos, dStrPre;

(*============================================*)
 PROCEDURE dChrAsgE(c:CHAR; VAR OutStr:DynStr);
(*============================================*)
     (* Assign a character to a dyn string *)

VAR temp :ARRAY[0..0] OF CHAR;

BEGIN

temp[0] := c;
dStrInE(temp, OutStr);

END dChrAsgE;

(*============================================*)
 PROCEDURE dChrAsgC(c:CHAR; VAR OutStr:DynStr);
(*============================================*)
     (* Assign a character to a dyn string *)

VAR temp :ARRAY[0..0] OF CHAR;

BEGIN

temp[0] := c;
dStrInC(temp, OutStr);

END dChrAsgC;

(*===========================================*)
 PROCEDURE dChrCat(c:CHAR; VAR OutStr:DynStr);
(*===========================================*)
     (* Concatenate one string onto another *)

VAR temp :DynStr;

BEGIN

dChrAsgC(c, temp);

dStrCat(temp, OutStr);

dStrDispose(temp);

END dChrCat;

(*===============================================================*)
 PROCEDURE dChrPos(s:DynStr; Pattern:CHAR; Start:INTEGER):INTEGER;
(*===============================================================*)
     (* Find the position of a char in a string *)
     (* Start looking at position Start *)
     (* Returns < 0 if not in the string *)

VAR temp :DynStr;
    res  :INTEGER;

BEGIN

dChrAsgC(Pattern, temp);

res := dStrPos(s, temp, Start);

dStrDispose(temp);

RETURN res;

END dChrPos;

(*==================================================*)
 PROCEDURE dChrPre(Prefix:CHAR; VAR OutStr:DynStr);
(*==================================================*)
     (* Prefix a character onto a string *)

VAR temp :DynStr;

BEGIN

dChrAsgC(Prefix, temp);

dStrPre(temp, OutStr);

dStrDispose(temp);

END dChrPre;

END DynStr1C.
