
(*############################*)
 IMPLEMENTATION MODULE DynStr2;         (* v1.0x-012187 *)
(*############################*)
                                       (* by Thomas Breeden, tmb@virginia.edu *)
(*
        Dynamically allocated string processing: less common procs.
*)

(*
Copyright (C) 1987 Thomas Breeden.

Permission to use, copy, modify and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided that
the above copyright notice appear in all copies and that both the copyright
notice and this permission notice appear in supporting documentation.
Thomas Breeden makes no representations about the suitability of this software
for any purpose. It is provided "as is" without express or implied warranty.
*)

FROM DynStr0 IMPORT DynStr;

(*=======================================*)
 PROCEDURE dStrFill(c:CHAR; VAR s:DynStr);
(*=======================================*)
     (* Fill the whole size of the string with the character *)

VAR  i:INTEGER;

BEGIN WITH s DO

FOR i := 0 TO VAL(INTEGER, siz)-1 DO
   str^[i] := c;
END;
str^[siz] := 0C;

END END dStrFill;

(*======================================*)
 PROCEDURE dStrPad(c:CHAR; VAR s:DynStr);
(*======================================*)
     (* Pad out the rest of the size of the string with the character *)

VAR  i:INTEGER;

BEGIN WITH s DO

FOR i := VAL(INTEGER, len) TO VAL(INTEGER, siz)-1 DO
   str^[i] := c;
END;
str^[siz] := 0C;

END END dStrPad;

(*==============================*)
 PROCEDURE dStrCut(VAR s:DynStr);
(*==============================*)
     (* Cut trailing blanks from the string *)

VAR  i:INTEGER;

BEGIN WITH s DO

i := len;
REPEAT
   DEC(i);
UNTIL (i < 0) OR (str^[i] # ' ');
INC(i);

len := i;
str^[i] := 0C;

END END dStrCut;

END DynStr2.

