
(*##########################*)
 IMPLEMENTATION MODULE Str0;                      (* v1.0-062688 Logitech MSDOS *)
(*##########################*)      (* from v2.0-amiga-062286 *)
                                       (* by Thomas Breeden, tmb@virginia.edu *)
(*
   Null delimited static string processing: Basic procedures.
*)

(*
Copyright (C) 1984-1988 Thomas Breeden.

Permission to use, copy, modify and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided that
the above copyright notice appear in all copies and that both the copyright
notice and this permission notice appear in supporting documentation.
Thomas Breeden makes no representations about the suitability of this software
for any purpose. It is provided "as is" without express or implied warranty.
*)

(*
VERSION HISTORY

v1.0-010384         -First version for PDP11 system

v1.1-051985         -Call to StrSet to initialize NullStr, now it should word
                     for either PDP11 byte sex or M68000 byte sex.

v2.0amiga-062286    -Finally gave in, this implements a null-delimited
                     string system with the same interface.
                    -Also, had to change input open array params to VAR
                     since TDI compiler insists on it.
                    -Also note: the TDI compiler considers all open array params
                     to be of different types from each other, so cannot do
                     a string assignment with them.

v1.0-062688 Logitech MSDOS
                    -Output VAR parameters changed back to non-VAR.
*)

(*--------------------------------------------------------------*)
 PROCEDURE StrAsg(InStr:ARRAY OF CHAR; VAR OutStr:ARRAY OF CHAR);
(*--------------------------------------------------------------*)
(*
     This proc assigns an input string to an output string.

VERSION HISTORY
NOTE
        1.Efficiency could be improved.

*)

VAR
     i  :CARDINAL;

BEGIN

i := 0;
LOOP
   IF i > HIGH(OutStr) THEN
      EXIT
   ELSIF (i > HIGH(InStr)) OR (InStr[i] = 0C) THEN
      OutStr[i] := 0C;
      EXIT;
   ELSE
     OutStr[i] := InStr[i];
     INC(i);
   END;
END;

END StrAsg;

(*-----------------------------------------*)
 PROCEDURE StrLen(S:ARRAY OF CHAR):CARDINAL;
(*-----------------------------------------*)
(*
     Function returns the length of the input string parameter.
*)

VAR len :CARDINAL;


BEGIN

len := 0;
WHILE (len <= HIGH(S)) AND (S[len] # 0C) DO
   INC(len);
END;

RETURN len;

END StrLen;

(*-------------------------------------------------*)
 PROCEDURE StrSet(VAR S:ARRAY OF CHAR; Len:CARDINAL);
(*-------------------------------------------------*)

BEGIN

IF Len <= HIGH(S) THEN
   S[Len] := 0C;
END;

END StrSet;

BEGIN

StrSet(NullStr,0);

END Str0.
