(*
  -- File:    version.mod

  -- This file is part of `tg'.

  -- `tg' is free software; you can redistribute it and/or modify
  -- it under the terms of the GNU General Public License as published by
  -- the Free Software Foundation; either version 2, or (at your option)
  -- any later version.

  -- `tg' is distributed in the hope that it will be useful,
  -- but WITHOUT ANY WARRANTY; without even the implied warranty of
  -- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  -- GNU General Public License for more details.

  -- You should have received a copy of the GNU General Public License
  -- along with `tg'; see the file COPYING.  If not, write to
  -- the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  -- Boston, MA 02111-1307, USA.
*)

(*##################################*)
 IMPLEMENTATION MODULE tgExceptions;        (* $VER: tgExceptions.mod 0.0 (29.3.4) *)
(*##################################*)

FROM EXCEPTIONS IMPORT   AllocateSource, CurrentNumber, ExceptionSource, IsCurrentSource,
                         IsExceptionalExecution, RAISE;

VAR  tgExc :ExceptionSource;

(*=================================*)
 PROCEDURE IstgException():BOOLEAN;
(*=================================*)
BEGIN

IF IsExceptionalExecution() THEN
   RETURN IsCurrentSource(tgExc);
END;

RETURN FALSE;

END IstgException;

(*====================================*)
 PROCEDURE tgException():tgExceptions;
(*====================================*)

BEGIN

RETURN VAL(tgExceptions, CurrentNumber(tgExc));

END tgException;

(*========================================================*)
 PROCEDURE Raise(which:tgExceptions);
(*========================================================*)

BEGIN

RAISE(tgExc, ORD(which), ""(*message*));

END Raise;

(*-------------------------*)
 BEGIN (* module init code *)
(*-------------------------*)

AllocateSource(tgExc);

END tgExceptions.
