
(*####################################*)
 IMPLEMENTATION MODULE tgM2Exceptions;        (* $VER: tgM2Exceptions.mod 0.9 (29.3.4) *)
(*####################################*)
(*
   This file is part of 'tgM2'.

   'tgM2' : A Test Driver Generator for Modula-2 programs
   Copyright (C) 2004 by Tom Breeden.

   'tgM2' is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   'tgM2' is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with 'tgM2'; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*)
(*
   'tgM2' was patterned on the Ada 95 program, 'tg' which is copyright 1996
    by Andre Spiegel with modifications by Ralf Reissing.
*)

FROM EXCEPTIONS IMPORT   AllocateSource, CurrentNumber, ExceptionSource, IsCurrentSource,
                         IsExceptionalExecution, RAISE;

VAR  tgExc :ExceptionSource;

(*=================================*)
 PROCEDURE IstgException():BOOLEAN;
(*=================================*)
BEGIN

IF IsExceptionalExecution() THEN
   RETURN IsCurrentSource(tgExc);
END;

RETURN FALSE;

END IstgException;

(*====================================*)
 PROCEDURE tgException():tgExceptions;
(*====================================*)

BEGIN

RETURN VAL(tgExceptions, CurrentNumber(tgExc));

END tgException;

(*========================================================*)
 PROCEDURE Raise(which:tgExceptions);
(*========================================================*)

BEGIN

RAISE(tgExc, ORD(which), ""(*message*));

END Raise;

(*-------------------------*)
 BEGIN (* module init code *)
(*-------------------------*)

AllocateSource(tgExc);

END tgM2Exceptions.
