
(*##############################*)
 IMPLEMENTATION MODULE tgM2Utils;        (* $VER: tgM2Utils.def 0.9 (8.5.04) *)
(*##############################*)
(*
   This file is part of 'tgM2'.

   'tgM2' : A Test Driver Generator for Modula-2 programs
   Copyright (C) 2004 by Tom Breeden.

   'tgM2' is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   'tgM2' is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with 'tgM2'; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*)
(*
   'tgM2' was patterned on the Ada 95 program, 'tg' which is copyright 1996
    by Andre Spiegel with modifications by Ralf Reissing.
*)

FROM STextIO  IMPORT WriteChar, WriteLn, WriteString;
FROM SWholeIO IMPORT WriteCard;

FROM DynStr0 IMPORT DynStr;
IMPORT Str0, Str1;

VAR   IndentSpaces  :CARDINAL;       (* number of spaces to be inserted *)
                                     (* before every LOC produced. *)

(*======================================*)
 PROCEDURE Put_Line(line:ARRAY OF CHAR);
(*======================================*)

VAR   i        :INTEGER;
      ch       :CHAR;
      prntChar :BOOLEAN;

BEGIN

(* >>>>>??????
WriteString(line);
<<<<< ????? *)

prntChar := FALSE;
FOR i := 0 TO VAL(INTEGER, LENGTH(line))-1 DO
   ch := line[i];
   IF prntChar OR (ch # ' ') THEN
      WriteChar(ch);
      prntChar := TRUE;
   END;
END;

WriteLn;

END Put_Line;

(*==============================*)
 PROCEDURE Put(s:ARRAY OF CHAR);
(*==============================*)
BEGIN

WriteString(s);

END Put;

(*===========================*)
 PROCEDURE Put_ds(ds:DynStr);
(*===========================*)
BEGIN

WriteString(ds.str^);

END Put_ds;

(*==================================*)
 PROCEDURE Put_Line_ds(line:DynStr);
(*==================================*)
BEGIN

Put_Line(line.str^);

END Put_Line_ds;

(*====================*)
 PROCEDURE Put_Indent;
(*====================*)

VAR  I :CARDINAL;

BEGIN

FOR I := 1 TO IndentSpaces DO
   Put(' ');
END;

END Put_Indent;

(*=================================*)
 PROCEDURE PutQuoted_ds(ds:DynStr);
(*=================================*)

VAR  i  :INTEGER;
     ch :CHAR;

BEGIN

FOR i := 0 TO VAL(INTEGER, ds.len)-1 DO

   ch := ds.str^[i];
   IF ch = "'" THEN
      Put('"');
   ELSE
      Put(ch);
   END;

END;

END PutQuoted_ds;

(*=====================================*)
 PROCEDURE PutQuoted(s:ARRAY OF CHAR);
(*=====================================*)

VAR  i  :INTEGER;
     ch :CHAR;

BEGIN

FOR i := 0 TO VAL(INTEGER, LENGTH(s))-1 DO

   ch := s[i];
   IF ch = "'" THEN
      Put('"');
   ELSE
      Put(ch);
   END;

END;

END PutQuoted;

(*======================================*)
 PROCEDURE PutIndented(s:ARRAY OF CHAR);
(*======================================*)
BEGIN

Put_Indent;
Put(s);

END PutIndented;

(*===================================*)
 PROCEDURE PutIndented_ds(ds:DynStr);
(*===================================*)
BEGIN

Put_Indent;
Put_ds(ds);

END PutIndented_ds;

(*=============================================*)
 PROCEDURE PutIndentedLine(Line:ARRAY OF CHAR);
(*=============================================*)

BEGIN

Put_Indent;
Put_Line(Line);

END PutIndentedLine;

(*=========================================*)
 PROCEDURE PutIndentedLine_ds(Line:DynStr);
(*=========================================*)
BEGIN

Put_Indent;
Put_Line_ds(Line);

END PutIndentedLine_ds;

(*===============================*)
 PROCEDURE PutNumber(n:CARDINAL);
(*===============================*)

BEGIN

WriteCard(n, 1);

END PutNumber;

(*==================*)
 PROCEDURE New_Line;
(*==================*)

BEGIN

WriteLn;

END New_Line;

(*===========================*)
 PROCEDURE Indent():CARDINAL;
(*===========================*)

BEGIN

RETURN IndentSpaces;

END Indent;

(*====================================*)
 PROCEDURE SetIndent(pIndent:CARDINAL);
(*====================================*)
BEGIN

IndentSpaces := pIndent;

END SetIndent;

(*==================================*)
 PROCEDURE IncrIndent(amt:CARDINAL);
(*==================================*)

BEGIN

INC(IndentSpaces, amt);

END IncrIndent;

(*==================================*)
 PROCEDURE DecrIndent(amt:CARDINAL);
(*==================================*)

BEGIN

IF IndentSpaces > amt THEN
   DEC(IndentSpaces, amt);
ELSE
   IndentSpaces := 0;
END;

END DecrIndent;

(*-------------------------*)
 BEGIN (* module init code *)
(*-------------------------*)

IndentSpaces := 0;

END tgM2Utils.
